///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

#ifndef MobTrapObjH
#define MobTrapObjH
//---------------------------------------------------------------------------

#include "MobObjectObj.h"

//...
//   ...
//      :)
const DWORD Trap_Sgn_UnknDw1 = 3148546049;   //(01 00 AB BB) // DW (12) (DWORD)
const DWORD Trap_Sgn_MagicStr = 3148546050;   //(02 00 AB BB) //   -    (8+STR) (String)
const DWORD Trap_Sgn_UnknDw2 = 3148546053;   //(05 00 AB BB) // DW (12) (DWORD)
const DWORD Trap_Sgn_UnknByte1 = 3148611589;   //(05 00 AC BB) // byte (9) (byte)
const DWORD Trap_Sgn_TrapPoints1 = 3148546051;   //(03 00 AB BB) //  1 (12+X*3) (X DWORD x 3)
const DWORD Trap_Sgn_TrapPoints2 = 3148546052;   //(04 00 AB BB) //  2 (12+X*2) (X DWORD x 2)
//{       }

//  ...
class TMob;

struct STrapPoint1
{
  DWORD CoordX;
  DWORD CoordY;
  DWORD Range;
};

struct STrapPoint2
{
  DWORD CoordX;
  DWORD CoordY;
};

//  ...
class TTrapObjBlock : public TObjectObjBlock //    .
{
  public:
    DWORD UnknDw1;   // DW
    String MagicStr;  //   -   
    DWORD UnknDw2;    // DW
    byte UnknByte1;  // byte
    DynamicArray <STrapPoint1> *TrapPoints1;  //  1
    DynamicArray <STrapPoint2> *TrapPoints2;  //  2
    //{       }

    // ...
    DWORD GetBlockSize();        //       .
    byte* GenBlock(DWORD& BlockSize);            // ...
    bool ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj);   //     .
};

typedef TTrapObjBlock* PTrapObjBlock;   //  %).

#endif
