///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SearchRepForm.h"
#include "MainForm.h"
#include "initer.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSearchRepF *SearchRepF;
//---------------------------------------------------------------------------
__fastcall TSearchRepF::TSearchRepF(TComponent* Owner)
        : TForm(Owner)
{
  FirstShowed = false;
  SearchDialCanceled = true;
}
//---------------------------------------------------------------------------

void TSearchRepF::UpdateInterf()
//        :).
{
  //     - \  .
  if (RepCB->Checked == true)
  {
    RepEd->Enabled = true;
  }
  else
  {
    RepEd->Enabled = false;
  };
};
//---------------------------------------------------------------------------

void __fastcall TSearchRepF::RepCBClick(TObject *Sender)
{
  UpdateInterf();
}
//---------------------------------------------------------------------------

void __fastcall TSearchRepF::CancelButClick(TObject *Sender)
{
  Close();  //   :).        
}
//---------------------------------------------------------------------------

void __fastcall TSearchRepF::GoButClick(TObject *Sender)
{
  //  ...      ...
  SearchDialCanceled = false;  //     
  Close();
  SaveInfo();

  /*TSynSearchOptions SO;
  //SO << ssoMatchCase;
  if (RepCB->Checked == true)
  {
    SO << ssoReplace;  //   - .
    MainF->ScriptEd->SearchReplace(SearchEd->Text,RepEd->Text,SO);
  }
  else
  {
    // .
    MainF->ScriptEd->SearchReplace(SearchEd->Text,NULL,SO);
  };*/

}
//---------------------------------------------------------------------------

void TSearchRepF::LoadInfo()
//    
{
  SearchEd->Text = SearchStr;
  RepEd->Text = RepStr;
  RepCB->Checked = MakeReplace;
  UpdateInterf();
};
//---------------------------------------------------------------------------

void TSearchRepF::SaveInfo()
//    
{
  SearchStr = SearchEd->Text;
  RepStr = RepEd->Text;
  MakeReplace = RepCB->Checked;
  MainIni->UpdateFile(); //    win9x.
};
//---------------------------------------------------------------------------

void __fastcall TSearchRepF::FormShow(TObject *Sender)
{
  if (FirstShowed == false)
  {
    //   ...
    LoadInfo();
  };        
}
//---------------------------------------------------------------------------



void __fastcall TSearchRepF::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  //   

  if (Key == VK_RETURN)
  {
    //  :)
    GoButClick(Sender);

    //    :)
    Key = NULL;
  };

  if (Key == VK_ESCAPE	)
  {
    //  :)
    CancelButClick(Sender);

    //    :)
    Key = NULL;
  };           
}
//---------------------------------------------------------------------------

